<template>
  <span v-on="$listeners">
    <g-link v-if="internal" class="reset" :to="to" :aria-label="ariaLabel">
      <slot />
    </g-link>
    <a v-else-if="mailto" class="mailtoui reset" :href="to" :aria-label="ariaLabel">
      <slot />
    </a>
    <a
      v-else
      class="reset"
      :href="`${to}?ref=arcadia`"
      rel="nofollow noopener noreferrer"
      target="_blank"
      :aria-label="ariaLabel"
    >
      <slot />
    </a>
  </span>
</template>

<script>
export default {
  name: 'HyperLink',
  props: {
    to: String,
    ariaLabel: String,
  },
  computed: {
    internal() {
      const isInternal = /^\/([a-z\-]+\/)*$/;
      return isInternal.test(this.to);
    },
    mailto() {
      const isMailTo = /^mailto:/;
      return isMailTo.test(this.to);
    },
  },
};
</script>
